/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDicomValue;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.exceptions.ConditionFailedException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidItemException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ValidationException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;

/**
* This item class contains the methods to set, get and validate the attribute present in Optical Selected Ophthalmic AxialLength Sequence .
 */

public class OpticalSelectedOphthalmicAxialLengthSequenceItem extends Item
{
	private static final long serialVersionUID = 1L;

	/**
	 * This constructor creates the item with default TransferSyntax 
	 */
	OpticalSelectedOphthalmicAxialLengthSequenceItem()
	{
		super();
	}

	/*
	 * This constructor calls the respective superclass constructor
	 * This constructor should throw exception if null TS is tried to be set
	 */
	/**
	 * This constructor creates the item with specified TransferSyntax 
	 * and default DictionaryReader
	 * @param objITransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 */
	OpticalSelectedOphthalmicAxialLengthSequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
	}

	/**
	 * This constructor creates OpticalSelectedOphthalmicAxialLengthSequenceItem with specified TransferSyntax and
	 * specified DictionaryReader.
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax.
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used.
	 */
	OpticalSelectedOphthalmicAxialLengthSequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
	}

	/*
	 * (non-Javadoc) This method validates the contents of the Item
	 * @see cdac.medinfo.sdk.dcm30_04.commoninterface.IItem#validate()
	 */
	/**
	 * Validates all the attributes in OpticalSelectedOphthalmicAxialLengthSequenceItem that are present in the DataSet
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidItemException throws InvalidItemException If Mandatory or Conditional element fails.
	 */
	public boolean validateForModule()  throws InvalidItemException
	{
		try{
			if(!contains(0x0022,0x1260))
				throw new ConditionFailedException("0022,1260");
			if(!contains(0x0022,0x1257))
				throw new ConditionFailedException("0022,1257");
		}
		catch(ConditionFailedException ce)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(ce.getMessage());
			}
			throw new ValidationException(this.getClass().getSimpleName(),ce); 
		}
		return true;
	}
	/**
	 * Retrieves pre-initialized object of Selected Total Ophthalmic Axial Length Sequence.If the module contains the sequence object
	 * it returns the same otherwise it creates the sequence adds to the module with proper initialization
	 * and then returns the object of sequence.
	 * @return SelectedTotalOphthalmicAxialLengthSequence - instance of Selected Total Ophthalmic Axial Length Sequence. 
	 */
	public SelectedTotalOphthalmicAxialLengthSequence getSelectedTotalOphthalmicAxialLengthSequence()
	{
		SelectedTotalOphthalmicAxialLengthSequence objSelectedTotalOphthalmicAxialLengthSequence = null;
		IDataElement objIDataElement =  getDataForTag(0x0022,0x1260);
		if(objIDataElement != null)
		{
			IDicomValue objIDicomValue = objIDataElement.getDicomValue();
			if(objIDicomValue != null)
				objSelectedTotalOphthalmicAxialLengthSequence = (SelectedTotalOphthalmicAxialLengthSequence)objIDicomValue;
		}
		else
		{
			DicomV3Factory objDicomV3Factory = DicomV3Factory.createInstance();
			int iVRTransferSyntax = objITransferSyntax.getVRTransferSyntax();
			objIDataElement = null;
			objSelectedTotalOphthalmicAxialLengthSequence = (SelectedTotalOphthalmicAxialLengthSequence)objDicomV3Factory.createSequence(0x0022,0x1260, objITransferSyntax, objIDictionaryReader);

			if(iVRTransferSyntax == DicomConstants.DCM_VR_IMPLICIT)
				objIDataElement = new ImplicitDE(0x0022,0x1260, objSelectedTotalOphthalmicAxialLengthSequence.getValue(),objIDictionaryReader);
			else
				objIDataElement = new ExplicitDE(0x0022,0x1260, DicomConstants.DCM_DT_SQ, objSelectedTotalOphthalmicAxialLengthSequence.getValue());
			objIDataElement.setTransferSyntax(objITransferSyntax);
			if(objIDataElement != null)
				addDataElement(objIDataElement);
		}
		return objSelectedTotalOphthalmicAxialLengthSequence;
	}
	/**
	 * Retrieves pre-initialized object of Selected Segmental Ophthalmic Axial Length Sequence.If the module contains the sequence object
	 * it returns the same otherwise it creates the sequence adds to the module with proper initialization
	 * and then returns the object of sequence.
	 * @return SelectedSegmentalOphthalmicAxialLengthSequence - instance of Selected Segmental Ophthalmic Axial Length Sequence. 
	 */
	public SelectedSegmentalOphthalmicAxialLengthSequence getSelectedSegmentalOphthalmicAxialLengthSequence()
	{
		SelectedSegmentalOphthalmicAxialLengthSequence objSelectedSegmentalOphthalmicAxialLengthSequence = null;
		IDataElement objIDataElement =  getDataForTag(0x0022,0x1257);
		if(objIDataElement != null)
		{
			IDicomValue objIDicomValue = objIDataElement.getDicomValue();
			if(objIDicomValue != null)
				objSelectedSegmentalOphthalmicAxialLengthSequence = (SelectedSegmentalOphthalmicAxialLengthSequence)objIDicomValue;
		}
		else
		{
			DicomV3Factory objDicomV3Factory = DicomV3Factory.createInstance();
			int iVRTransferSyntax = objITransferSyntax.getVRTransferSyntax();
			objIDataElement = null;
			objSelectedSegmentalOphthalmicAxialLengthSequence = (SelectedSegmentalOphthalmicAxialLengthSequence)objDicomV3Factory.createSequence(0x0022,0x1257, objITransferSyntax, objIDictionaryReader);

			if(iVRTransferSyntax == DicomConstants.DCM_VR_IMPLICIT)
				objIDataElement = new ImplicitDE(0x0022,0x1257, objSelectedSegmentalOphthalmicAxialLengthSequence.getValue(),objIDictionaryReader);
			else
				objIDataElement = new ExplicitDE(0x0022,0x1257, DicomConstants.DCM_DT_SQ, objSelectedSegmentalOphthalmicAxialLengthSequence.getValue());
			objIDataElement.setTransferSyntax(objITransferSyntax);
			if(objIDataElement != null)
				addDataElement(objIDataElement);
		}
		return objSelectedSegmentalOphthalmicAxialLengthSequence;
	}
}
